/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/


#include "`$INSTANCE_NAME`_WaveRoutines.h"
#include "`$INSTANCE_NAME`_sine10.h"

//#include <sine10.h> // 10-bit sine table



//==============================================================================
// Fill Buffer with 1 period of Sine wave centered arounf 128u
// amplitude [-127 to 127], phase [0 to NumSamples-1]
//==============================================================================

void `$INSTANCE_NAME`_CreateSineWave_C(int16 ampl, int16 phase)  // fill buffer with 1-period sine wave centered around 128u 
{
    const double scale_t = (double) MYSINE_TABLE_SIZE/(double) `$INSTANCE_NAME`_NumSamples; // sine table size 0..1023 scaled to 0..255

    phase++; // correction (+1)
    //phase++; // correction (+1)
    
    if (ampl > 127) ampl=127; else if (ampl < -127) ampl=-127;  //SINE_C128  (signed)

    uint16 i;
    for (i=0; i<`$INSTANCE_NAME`_NumSamples; i++)
    {
            //uint16 theta = (i+phase_shift)<<6; // sine table size 0..1023 scaled to 0..255 
            //uint16 theta = (i*(MYSINE_TABLE_SIZE/WaveGen_1_NumSamples)) + (phase_shift+phase_corct)*(MYSINE_TABLE_SIZE/phase_steps); // sine table size 0..1023 scaled to 0..255
            //uint16 theta = (i*(MYSINE_TABLE_SIZE/WaveGen_1_NumSamples)) + phase*(MYSINE_TABLE_SIZE/phase_steps); // sine table size 0..1023 scaled to 0..255
            //uint16 theta = i     * ((double) MYSINE_TABLE_SIZE/(double) `$INSTANCE_NAME`_NumSamples)
            //             + phase * ((double) MYSINE_TABLE_SIZE/(double) `$INSTANCE_NAME`_NumSamples); // sine table size 0..1023 scaled to 0..255

            //int16 theta = (i + phase) * ((double) MYSINE_TABLE_SIZE/(double) `$INSTANCE_NAME`_NumSamples); // sine table size 0..1023 scaled to 0..255
        
            int16 theta = (i + phase) * scale_t; // sine table size 0..1023 scaled to 0..255
                       
                        
            ///Buffer[i] = 128 + (ampl * 1025 * mysine(phase) >> 20 >> 1); // 0-255;
            //WaveGen_1_Buffer[i] = ((uint32) (ampl_v * (1024+mysine(phase))) >> 10); // 0-255;
            //WaveGen_1_Buffer[i] = 128 + (ampl_v * mysine(theta) / 1023  ); // 0-255;
            //`$INSTANCE_NAME`_Buffer[i] = 128u + (ampl * mysine(theta) / 1024 ); // ampl_v=int8 [-128..127];
            `$INSTANCE_NAME`_Buffer[i] = 128u + ((ampl * mysine(theta)) >> 10 ); // ampl_v=int8 [-128..127];
            
            ///WaveGen_1_Buffer[i] = 127 + ((double) ampl * (double) mysine(phase) / 1023.0 * (125.0/128.0)  ); // 0-255;

            //`$INSTANCE_NAME`_Buffer[i] = (int8) (ampl * mysine(theta) / 1024 ); // ampl_v=int8 [-128..127];
            //WaveGen_1_Buffer[i] = 128u+64u + (int8)(ampl_v * mysine(theta) / 1024 ); // ampl_v=int8 [-128..127];//filter
            //`$INSTANCE_NAME`_Buffer[i] = 128u+64u + (int8)(ampl * mysine(theta) / 1024 ); // ampl_v=int8 [-128..127];//filter
    }
    
}

//==============================================================================
// Fill Buffer with 1 period of Sine wave bottomed at 0 
// amplitude [0 to 255], phase [0 to NumSamples-1]
//==============================================================================

void `$INSTANCE_NAME`_CreateSineWave_B(int16 ampl, int16 phase)  // fill buffer with 1-period sine wave [0 .. 255] 
{
    const double scale_t = (double) MYSINE_TABLE_SIZE/(double) `$INSTANCE_NAME`_NumSamples; // sine table size 0..1023 scaled to 0..255

    phase++; // correction (+1)
    
    if (ampl > 255) ampl=255; else if (ampl < 0) ampl=0;  //SINE  (unsigned)

    uint16 i;
    for (i=0; i<`$INSTANCE_NAME`_NumSamples; i++)
    {
            int16 theta = (i + phase) * scale_t; // sine table size 0..1023 scaled to 0..255
                       
                        
            ///Buffer[i] = 128 + (ampl * 1025 * mysine(phase) >> 20 >> 1); // 0-255;
            //WaveGen_1_Buffer[i] = ((uint32) (ampl_v * (1024+mysine(phase))) >> 10); // 0-255;
            //WaveGen_1_Buffer[i] = 128 + (ampl_v * mysine(theta) / 1023  ); // 0-255;
            //`$INSTANCE_NAME`_Buffer[i] = 128u + (ampl * mysine(theta) / 1024 ); // ampl_v=int8 [-128..127];
            `$INSTANCE_NAME`_Buffer[i] = ((ampl * (1024 + mysine(theta))) >> 11 ); // ampl_v=uint8 [0..255]; // more/less symmetric
            //`$INSTANCE_NAME`_Buffer[i] = ((uint32)(ampl * (1023.5 + mysine(theta))) >> 11 ); // ampl_v=uint8 [0..255]; // more/less symmetric
            //`$INSTANCE_NAME`_Buffer[i] = ((ampl * (1024 + mysine(theta))) / 1023 / 2); // ampl_v=uint8 [0..255];
    }
    
}


//==============================================================================
// Fill Buffer with 1 period of Sine wave with amplitude and offset
// amplitude [-127 to 127], offset [0 to 255] phase [0 to NumSamples-1]
// return 1 - overload, 0 - inside [0-255] range
//==============================================================================

uint8 
//void
`$INSTANCE_NAME`_CreateSineWave_AmplOffset(int16 ampl, int16 offset, int16 phase)  // fill buffer with 1-period sine wave centered around 128u 
{
    
    uint8 result = 0;

    const double scale_t = (double) MYSINE_TABLE_SIZE/(double) `$INSTANCE_NAME`_NumSamples; // sine table size 0..1023 scaled to 0..255

    phase++; // correction (+1)

    if ((ampl+offset>255) || (ampl+offset<0)) result = 1; // error overload
    
    //if (ampl > 127) ampl=127; else if (ampl < -127) ampl=-127;  //SINE_C128  (signed)

    uint16 i;
    for (i=0; i<`$INSTANCE_NAME`_NumSamples; i++)
    {
            //uint16 theta = (i+phase_shift)<<6; // sine table size 0..1023 scaled to 0..255 
            //uint16 theta = (i*(MYSINE_TABLE_SIZE/WaveGen_1_NumSamples)) + (phase_shift+phase_corct)*(MYSINE_TABLE_SIZE/phase_steps); // sine table size 0..1023 scaled to 0..255
            //uint16 theta = (i*(MYSINE_TABLE_SIZE/WaveGen_1_NumSamples)) + phase*(MYSINE_TABLE_SIZE/phase_steps); // sine table size 0..1023 scaled to 0..255
            //uint16 theta = i     * ((double) MYSINE_TABLE_SIZE/(double) `$INSTANCE_NAME`_NumSamples)
            //             + phase * ((double) MYSINE_TABLE_SIZE/(double) `$INSTANCE_NAME`_NumSamples); // sine table size 0..1023 scaled to 0..255

            //int16 theta = (i + phase) * ((double) MYSINE_TABLE_SIZE/(double) `$INSTANCE_NAME`_NumSamples); // sine table size 0..1023 scaled to 0..255
        
            int16 theta = (i + phase) * scale_t; // sine table size 0..1023 scaled to 0..255
                       
                        
            ///Buffer[i] = 128 + (ampl * 1025 * mysine(phase) >> 20 >> 1); // 0-255;
            //WaveGen_1_Buffer[i] = ((uint32) (ampl_v * (1024+mysine(phase))) >> 10); // 0-255;
            //WaveGen_1_Buffer[i] = 128 + (ampl_v * mysine(theta) / 1023  ); // 0-255;
            //`$INSTANCE_NAME`_Buffer[i] = 128u + (ampl * mysine(theta) / 1024 ); // ampl_v=int8 [-128..127];
            //`$INSTANCE_NAME`_Buffer[i] = 128u + ((ampl * mysine(theta)) >> 10 ); // ampl_v=int8 [-128..127];
            `$INSTANCE_NAME`_Buffer[i] = offset + ((ampl * mysine(theta)) >> 10 ); // ampl_v=int8 [-128..127];
            
            ///WaveGen_1_Buffer[i] = 127 + ((double) ampl * (double) mysine(phase) / 1023.0 * (125.0/128.0)  ); // 0-255;

            //`$INSTANCE_NAME`_Buffer[i] = (int8) (ampl * mysine(theta) / 1024 ); // ampl_v=int8 [-128..127];
            //WaveGen_1_Buffer[i] = 128u+64u + (int8)(ampl_v * mysine(theta) / 1024 ); // ampl_v=int8 [-128..127];//filter
            //`$INSTANCE_NAME`_Buffer[i] = 128u+64u + (int8)(ampl * mysine(theta) / 1024 ); // ampl_v=int8 [-128..127];//filter
    }
    
    return result;
}


//==============================================================================
// Fill Buffer with 1 period of Sine wave bottomed at 0 
// amplitude [0 to 255], phase [0 to NumSamples-1]
//==============================================================================

uint8 `$INSTANCE_NAME`_CreateSineWave_MinMax(int16 min, int16 max, int16 phase)  // fill buffer with 1-period sine wave [0 .. 255] 
{
    uint8 result = 0;
    const double scale_t = (double) MYSINE_TABLE_SIZE/(double) `$INSTANCE_NAME`_NumSamples; // sine table size 0..1023 scaled to 0..255

    phase++; // correction (+1)

    if ((max>255) || (min<0)) result = 1; // error bounds
    
    //if (ampl > 255) ampl=255; else if (ampl < 0) ampl=0;  //SINE  (unsigned)

    uint16 ampl = max - min;
    
    uint16 i;
    for (i=0; i<`$INSTANCE_NAME`_NumSamples; i++)
    {
            int16 theta = (i + phase) * scale_t; // sine table size 0..1023 scaled to 0..255
                       
                        
            ///Buffer[i] = 128 + (ampl * 1025 * mysine(phase) >> 20 >> 1); // 0-255;
            //WaveGen_1_Buffer[i] = ((uint32) (ampl_v * (1024+mysine(phase))) >> 10); // 0-255;
            //WaveGen_1_Buffer[i] = 128 + (ampl_v * mysine(theta) / 1023  ); // 0-255;
            //`$INSTANCE_NAME`_Buffer[i] = 128u + (ampl * mysine(theta) / 1024 ); // ampl_v=int8 [-128..127];
            `$INSTANCE_NAME`_Buffer[i] = ((ampl * (1024 + mysine(theta))) >> 11 ); // ampl_v=uint8 [0..255]; // more/less symmetric
            //`$INSTANCE_NAME`_Buffer[i] = ((uint32)(ampl * (1023.5 + mysine(theta))) >> 11 ); // ampl_v=uint8 [0..255]; // more/less symmetric
            //`$INSTANCE_NAME`_Buffer[i] = ((ampl * (1024 + mysine(theta))) / 1023 / 2); // ampl_v=uint8 [0..255];
    }
    
    return result;
}

//==============================================================================
// Fill Buffer with 1 period of linear Ramp wave centered at 128u 
// amplitude [-127 to 127], phase [0 to NumSamples-1]
//==============================================================================
// todo: phase not work
void `$INSTANCE_NAME`_CreateRampWave_C(int16 ampl, int16 phase)  // fill buffer with 1-period ramp wave [0 .. 255] 
{
    uint16 i;
    
    if (ampl > 127) ampl=127; else if (ampl < -127) ampl=-127;  //xx_C128  (signed)
    
    phase++; // correction (+1) // incorrect

    int16 p = -phase;
    p = p % `$INSTANCE_NAME`_NumSamples;
    p = (p < 0)? p + (`$INSTANCE_NAME`_NumSamples-0) : p;

    /*
    // not work->
    //phase = phase % `$INSTANCE_NAME`_NumSamples;
    //phase = (phase < 0)? phase : phase - (`$INSTANCE_NAME`_NumSamples-1);

    int16 i;
    for (i=0; i<`$INSTANCE_NAME`_NumSamples; i++)
    {
        if (i+phase<=0)
           `$INSTANCE_NAME`_Buffer[i] = 128 + ampl + 2 * ampl * (i + phase) / (`$INSTANCE_NAME`_NumSamples-1); 
           //`$INSTANCE_NAME`_Buffer[i] = 0;
        else 
           `$INSTANCE_NAME`_Buffer[i] = 128 - ampl + 2 * ampl * (i + phase) / (`$INSTANCE_NAME`_NumSamples-1);
           //`$INSTANCE_NAME`_Buffer[i] = 0;
    }
    */
    
    /*
    // ok->
    for (i=0; i<`$INSTANCE_NAME`_NumSamples; i++)
    {
        if (i<p)
            //`$INSTANCE_NAME`_Buffer[i] = 128 - ampl + 2 * ampl * (i - p) / (`$INSTANCE_NAME`_NumSamples-1) + 2 * ampl * `$INSTANCE_NAME`_NumSamples / (`$INSTANCE_NAME`_NumSamples-1);  
            `$INSTANCE_NAME`_Buffer[i] = 128 - ampl + 2*ampl * ((i - p) + `$INSTANCE_NAME`_NumSamples) / (`$INSTANCE_NAME`_NumSamples-1);  
        else 
            `$INSTANCE_NAME`_Buffer[i] = 128 - ampl + 2*ampl * (i - p) / (`$INSTANCE_NAME`_NumSamples-1);
    }        
    */
    
    for (i=0; i<p; i++)
        //`$INSTANCE_NAME`_Buffer[i] = 128 - ampl + 2 * ampl * (i - p) / (`$INSTANCE_NAME`_NumSamples-1) + 2 * ampl * `$INSTANCE_NAME`_NumSamples / (`$INSTANCE_NAME`_NumSamples-1);  
        `$INSTANCE_NAME`_Buffer[i] = 128u - ampl + (2*ampl * ((i - p) + `$INSTANCE_NAME`_NumSamples)) / (`$INSTANCE_NAME`_NumSamples-1);  
    
    for (i=p; i<`$INSTANCE_NAME`_NumSamples; i++)
        `$INSTANCE_NAME`_Buffer[i] = 128u - ampl + (2*ampl * (i - p)) / (`$INSTANCE_NAME`_NumSamples-1);

        
}

//==============================================================================
// Fill Buffer with 1 period of linear ramp wave bottomed at 0 
// amplitude [0 to 255], phase [0 to NumSamples-1]
//==============================================================================

void `$INSTANCE_NAME`_CreateRampWave_B(int16 ampl, int16 phase)  // fill buffer with 1-period ramp wave [0 .. 255] 
{ 
    uint16 i;
    
    if (ampl > 255) ampl=255; else if (ampl < 0) ampl=0;  //SINE  (unsigned)
    
    phase++; // correction (+1) 

    int16 p = -phase;
    p = p % `$INSTANCE_NAME`_NumSamples;
    p = (p < 0)? p + (`$INSTANCE_NAME`_NumSamples-0) : p;

    /*
    for (i=0; i<`$INSTANCE_NAME`_NumSamples; i++)
    {
        if (i<p)
            //`$INSTANCE_NAME`_Buffer[i] = ampl * (i - p) / (`$INSTANCE_NAME`_NumSamples-1) + ampl * `$INSTANCE_NAME`_NumSamples / (`$INSTANCE_NAME`_NumSamples-1);  
            `$INSTANCE_NAME`_Buffer[i] = ampl * ((i - p) + `$INSTANCE_NAME`_NumSamples) / (`$INSTANCE_NAME`_NumSamples-1);  
        else 
            `$INSTANCE_NAME`_Buffer[i] = ampl * (i - p) / (`$INSTANCE_NAME`_NumSamples-1);
    }        
    */
    
    for (i=0; i<p; i++)
        `$INSTANCE_NAME`_Buffer[i] = ampl * (i - p) / (`$INSTANCE_NAME`_NumSamples-1) + ampl * `$INSTANCE_NAME`_NumSamples / (`$INSTANCE_NAME`_NumSamples-1);  
        //`$INSTANCE_NAME`_Buffer[i] = (2*ampl+1) * ((i - p) + `$INSTANCE_NAME`_NumSamples) / (2*(`$INSTANCE_NAME`_NumSamples-1));  
    
    for (i=p; i<`$INSTANCE_NAME`_NumSamples; i++)
        `$INSTANCE_NAME`_Buffer[i] = ampl * (i - p) / (`$INSTANCE_NAME`_NumSamples-1);
        //`$INSTANCE_NAME`_Buffer[i] = (2*ampl+1) * (i - p) / (2*(`$INSTANCE_NAME`_NumSamples-1));
            
}


//==============================================================================
// Fill Buffer with 1 period of triangle wave centered at 128u 
// amplitude [-127 to 127], phase [0 to NumSamples-1]
//==============================================================================

void `$INSTANCE_NAME`_CreateTrngWave_C(int16 ampl, int16 phase)  // fill buffer with 1-period ramp wave [0 .. 255] 
{
}


//==============================================================================
// Fill Buffer with 1 period of triangle wave bottomed at 0 
// amplitude [0 to 255], phase [0 to NumSamples-1]
//==============================================================================

void `$INSTANCE_NAME`_CreateTrngWave_B(int16 ampl, int16 phase)  // fill buffer with 1-period ramp wave [0 .. 255] 
{
} 


//==============================================================================
// Fill Buffer with 1 period of Sine wave with amplitude and offset
// amplitude [-127 to 127], offset [0 to 255] phase [0 to NumSamples-1]
// return 1 - overload, 0 - inside [0-255] range
//==============================================================================
/*
uint8 `$INSTANCE_NAME`_CreateSineWave_AmplOffset(int16 ampl, int16 offset, int16 phase)  // fill buffer with 1-period sine wave centered around 128u 
{
    uint8 result = 0;

    const double scale_t = (double) MYSINE_TABLE_SIZE/(double) `$INSTANCE_NAME`_NumSamples; // sine table size 0..1023 scaled to 0..255

    phase++; // correction (+1)

    if ((ampl+offset>255) || (ampl+offset<0)) result = 1; // error overload
    
   
}
*/

//==============================================================================
// Fill Buffer with 1 period of Sine wave bottomed at 0 
// amplitude [0 to 255], phase [0 to NumSamples-1]
//==============================================================================
/*
uint8 `$INSTANCE_NAME`_CreateSineWave_MinMax(int16 min, int16 max, int16 phase)  // fill buffer with 1-period sine wave [0 .. 255] 
{
    uint8 result = 0;
    const double scale_t = (double) MYSINE_TABLE_SIZE/(double) `$INSTANCE_NAME`_NumSamples; // sine table size 0..1023 scaled to 0..255

    phase++; // correction (+1)

    if ((max>255) || (min<0)) result = 1; // error bounds
    
    //if (ampl > 255) ampl=255; else if (ampl < 0) ampl=0;  //SINE  (unsigned)

    uint16 ampl = max - min;
    
    
}
*/


/* [] END OF FILE */
